<?php
/**
 * @package     ContentBuilder
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

if(file_exists(JPATH_SITE . '/administrator/components/com_contentbuilder/classes/contentbuilder_helpers.php')) {
    require_once(JPATH_SITE . '/administrator/components/com_contentbuilder/classes/contentbuilder_helpers.php');
}

class plgContentbuilder_listactionTrash extends JPlugin
{
        function __construct( &$subject, $params )
        {
            parent::__construct($subject, $params);
        }
        
        /**
         * @param int $form_id use it to find the record for the appropriate view
         * @param array $record_ids an array of record_id. Please note that the record_ids may be _non_numeric_
         * @return string error
         */
        function onBeforeAction($form_id, $record_ids){

            $lang = JFactory::getLanguage();
            $lang->load('plg_contentbuilder_listaction_sendemail', JPATH_ADMINISTRATOR);

            $json_conf = null;
            $conf_folder = JPATH_SITE . '/media/contentbuilder/plugins/sendemail/';
            $conf = JPATH_SITE . '/media/contentbuilder/plugins/sendemail/config.json';

            if(file_exists($conf)){

                $json_conf = @json_decode(file_get_contents($conf));
            }
            else{

                if(!file_exists($conf_folder)){

                    JFolder::create($conf_folder);
                }

                $default = new stdClass();
                $default->forms = array();
                $default->forms[] = new stdClass();
                $default->forms[0]->email_fields = 'FIELDNAME3;FIELDNAME4';
                $default->forms[0]->fields = 'FIELDNAME;FIELDNAME2';
                $default->forms[0]->subject = 'You go a notification {FIELDNAME}';
                $default->forms[0]->template = 'Please note our latest information: {FIELDNAME2}';

                $content = @json_encode($default);
                JFile::write($conf);

                JFactory::getApplication()->enqueueMessage('Please create a config in /media/contentbuilder/plugins/sendemail/config.json first!');

                return '';
            }

            if(!isset($json_conf->forms) || !isset($json_conf->forms[$form_id]) || !is_object($json_conf)){

                JFactory::getApplication()->enqueueMessage('Could not load /media/contentbuilder/plugins/sendemail/config.json for this form. Form id not given or malformed!');

                return '';
            }

            $emails = explode(';',$json_conf->forms[$form_id]->email_fields);
            $fields = explode(';',$json_conf->forms[$form_id]->fields);
            $subject = $json_conf->forms[$form_id]->subject;
            $template = $json_conf->forms[$form_id]->template;

            $db = JFactory::getDBO();

            $db->setQuery("Select * From #__contentbuilder_forms Where id = " . $db->quote($form_id));
            $form = $db->loadObject();

            if($form->type == 'com_contentbuilder'){

                $db->setQuery("Select * From #__contentbuilder_storages Where id = " . $db->quote($form->reference_id));
                $storage = $db->loadObject();

                foreach($record_ids As $record_id){

                    $db->setQuery("Select * From " . $db->quoteName('#__' . $storage->name) . " Where id = " . $db->quote($record_id));
                    $record = $db->loadObject();

                    foreach($fields as $field){

                        if(isset($record->$field)){

                            $template = str_replace($field, $record->$field, $template);
                            $subject = str_replace($field, $record->$field, $subject);
                        }
                    }

                    foreach($emails as $email){

                        if(isset($record->$email) && contentbuilder_is_email($record->$email)){

                            JFactory::getMailer()->sendMail(
                                JFactory::getApplication()->getCfg('mailfrom'),
                                JFactory::getApplication()->getCfg('fromname'),
                                $record->$email,
                                $subject,
                                $template
                            );
                        }
                    }
                }
            }
            else if($form->type == 'com_breezingforms'){

                foreach($record_ids As $record_id){

                    $db->setQuery("Select * From #__facileforms_subrecords Where record = " . $db->quote($record_id));
                    $record_fields = $db->loadObjectList();

                    foreach($record_fields as $record_field){

                        if(in_array($record_field->name, $fields)){

                            $template = str_replace($record_field->name, $record_field->value, $template);
                            $subject = str_replace($record_field->name, $record_field->value, $subject);
                        }
                    }

                    foreach($record_fields as $record_field){

                        if(in_array($record_field->name, $emails) && contentbuilder_is_email($record_field->value)){

                            JFactory::getMailer()->sendMail(
                                JFactory::getApplication()->getCfg('mailfrom'),
                                JFactory::getApplication()->getCfg('fromname'),
                                $record_field->value,
                                $subject,
                                $template
                            );
                        }
                    }
                }
            }
            
            JFactory::getApplication()->enqueueMessage(JText::_('COM_CONTENTBUILDER_EMAIL_SUCCESSFULL'));
        
            return ''; // no error
        }
        
        /**
         *
         * @param int $form_id use it to find the record for the appropriate view
         * @param array $record_ids an array of record_id. Please note that the record_ids may be _non_numeric_
         * @param type $previous_errors error messages thrown by onBeforeAction
         * @return type 
         */
        function onAfterAction($form_id, $record_ids, $previous_errors){
            return ''; // no error
        }
        
        /**
         * This event will be triggered on article creation and update.
         * 
         * It gives you the chance to force the article to stay into previously set states
         * 
         * In this case we delete the newly created article if there is a trashed state assigned to this record.
         * 
         * @param int $form_id
         * @param mixed $record_id
         * @param int $article_id 
         * @return string message
         */
        function onAfterArticleCreation($form_id, $record_id, $article_id){
            
            return '';
        }
}
